VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsRelativePaths"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Public strSrcPath As String
Public strRelativePath As String
Public strFullPath As String

Private Sub RightCut(strString As String, ByVal iNumberOfBytes As Integer)

strString = Left$(strString, Len(strString) - iNumberOfBytes)

End Sub

Private Sub LeftCut(strString As String, ByVal iNumberOfBytes As Integer)

strString = Right$(strString, Len(strString) - iNumberOfBytes)

End Sub

Private Function LeftCutChar(strString As String, strChar As String) As Boolean

Dim i As Long
Dim iLen As Long
iLen = Len(strString)
LeftCutChar = True

Do
    i = i + 1
    If Mid$(strString, i, 1) = strChar Then
        LeftCut strString, i
        Exit Do
    ElseIf i = iLen Then
        LeftCutChar = False
        Exit Do
    End If
Loop

End Function

Public Function RelativePathBuild() As String
Dim i As Integer
Dim bResult As Boolean

If Right$(strSrcPath, 1) = "\" Then RightCut strSrcPath, 1
If Left$(strRelativePath, 1) = "\" Then LeftCut strRelativePath, 1

Do
    If Left$(strRelativePath, 2) = ".\" Then
        RightCut strRelativePath, 2
    ElseIf Left$(strRelativePath, 3) = "..\" Then
        LeftCut strRelativePath, 3
        bResult = RightCutChar(strSrcPath, "\")
        If bResult = False Then Exit Function
    Else
        Exit Do
    End If
Loop

RelativePathBuild = strSrcPath + "\" + strRelativePath
    
End Function

Public Function RelativePathGet() As String
Dim i As Integer
Dim iMaxLen As Integer
Dim strResult As String
Dim bHasFound As Boolean

If Right$(strSrcPath, 1) <> "\" Then strSrcPath = strSrcPath + "\"

If Len(strSrcPath) > Len(strFullPath) Then
    iMaxLen = Len(strSrcPath)
Else
    iMaxLen = Len(strFullPath)
End If

For i = iMaxLen To 1 Step -1
    If LCase(Left$(strSrcPath, i)) = LCase(Left$(strFullPath, i)) Then
        bHasFound = True
        Exit For
    End If
    If Mid$(strSrcPath, i, 1) = "\" Then strResult = strResult + "..\"
Next

If bHasFound = False Then RelativePathGet = strFullPath: Exit Function

strResult = strResult + Right$(strFullPath, Len(strFullPath) - i)
RelativePathGet = strResult

End Function

Private Function RightCutChar(strString As String, strChar As String) As Boolean

Dim i As Long
Dim iLen As Long
iLen = Len(strString)
RightCutChar = True

Do
    i = i + 1
    If Mid$(strString, iLen - i + 1, 1) = strChar Then
        RightCut strString, i
        Exit Do
    ElseIf i = iLen Then
        RightCutChar = False
        Exit Do
    End If
Loop

End Function



